#ifndef MALACHSCRIPT_LEXTOKENKIND_HPP
#define MALACHSCRIPT_LEXTOKENKIND_HPP

#include <cstdint>
namespace MalachScript::Parser {
    enum class LexTokenKind : uint8_t {
        Unknown,
        EndOfFile,
        Whitespace,

        // Symbols
        StarSymbol,
        StarStarSymbol,
        SlashSymbol,
        PercentSymbol,
        PlusSymbol,
        MinusSymbol,
        LessThanEqualsSymbol,
        LessThanSymbol,
        GreaterThanEqualsSymbol,
        GreaterThanSymbol,
        OpenParenthesisSymbol,
        CloseParenthesisSymbol,
        EqualsEqualsSymbol,
        ExclamationMarkEqualsSymbol,
        QuestionMarkSymbol,
        ColonSymbol,
        EqualsSymbol,
        PlusEqualsSymbol,
        MinusEqualsSymbol,
        StarEqualsSymbol,
        SlashEqualsSymbol,
        PercentEqualsSymbol,
        StarStarEqualsSymbol,
        PlusPlusSymbol,
        MinusMinusSymbol,
        AmpersandSymbol,
        CommaSymbol,
        OpenCurlyParenthesisSymbol,
        CloseCurlyParenthesisSymbol,
        SemicolonSymbol,
        VerticalLineSymbol,
        CaretSymbol,
        TildeSymbol,
        LessThanLessThanSymbol,
        GreaterThanGreaterThanSymbol,
        GreaterThanGreaterThanGreaterThanSymbol,
        AmpersandEqualsSymbol,
        VerticalLineEqualsSymbol,
        CaretEqualsSymbol,
        LessThanLessThanEqualsSymbol,
        GreaterThanGreaterThanEqualsSymbol,
        GreaterThanGreaterThanGreaterThanEqualsSymbol,
        DotSymbol,
        AmpersandAmpersandSymbol,
        VerticalLineVerticalLineSymbol,
        ExclamationMarkSymbol,
        OpenBlockParenthesisSymbol,
        CloseBlockParenthesisSymbol,
        CaretCaretSymbol,
        AtSymbol,
        ExclamationMarkIsSymbol,
        ColonColonSymbol,

        // Keywords
        AndKeyword,
        AbstractKeyword,
        AutoKeyword,
        BoolKeyword,
        BreakKeyword,
        CaseKeyword,
        CastKeyword,
        CatchKeyword,
        ClassKeyword,
        ConstKeyword,
        ContinueKeyword,
        DefaultKeyword,
        DoKeyword,
        DoubleKeyword,
        ElseKeyword,
        EnumKeyword,
        ExplicitKeyword,
        ExternalKeyword,
        FalseKeyword,
        FinalKeyword,
        FloatKeyword,
        ForKeyword,
        FromKeyword,
        FuncdefKeyword,
        FunctionKeyword,
        GetKeyword,
        IfKeyword,
        ImportKeyword,
        InKeyword,
        InoutKeyword,
        IntKeyword,
        InterfaceKeyword,
        Int8Keyword,
        Int16Keyword,
        Int32Keyword,
        Int64Keyword,
        IsKeyword,
        MixinKeyword,
        NamespaceKeyword,
        NotKeyword,
        NullKeyword,
        OrKeyword,
        OutKeyword,
        OverrideKeyword,
        PrivateKeyword,
        PropertyKeyword,
        ProtectedKeyword,
        ReturnKeyword,
        SetKeyword,
        SharedKeyword,
        SuperKeyword,
        SwitchKeyword,
        ThisKeyword,
        TrueKeyword,
        TryKeyword,
        TypedefKeyword,
        UintKeyword,
        Uint8Keyword,
        Uint16Keyword,
        Uint32Keyword,
        Uint64Keyword,
        VoidKeyword,
        WhileKeyword,
        XorKeyword,

        // Literals
        FloatLiteral,
        IntegerLiteral,
        StringLiteral,
        Identifier,
    };
}

#endif // MALACHSCRIPT_LEXTOKENKIND_HPP
